#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vi1;
typedef vector<vi1> vi2;

void stampa(vi2& niz, int n, int m)
{ for(int i=1;i<=n;i++)
   { cout<<endl;
     for(int k=1;k<=m;k++) cout<<niz[i][k]<<" ";
   }
}

void stampa2(vi1& niz, int n)
{ cout<<endl;
  for(int i=1;i<=n;i++) cout<<niz[i]<<" ";
}

int main()
{ int i, k, kn, m, n, x, y, val, tmp, suma;
  int skp, maz, levo, gore;
  cin>>n>>m;
  vi2 mata(n+1, vi1(m+1));
  cin>>kn;
  //stampa(niz, n, m);
  for(i=0;i<kn;i++)
   { cin>>x>>y;
     mata[x][y]=-1;//crna boja
   }
  //stampa(mata, n, m);
  vi1 boja(1);//niz za boje
  maz=0;
  //prvi red
  for(k=1;k<=m;k++)
   {if(mata[1][k]==0)//nije crna
     { if(mata[1][k-1]>0) mata[1][k]=maz;//levo ima boja
       else//levo je crna ili zid
        { boja.push_back(++maz);
          mata[1][k]=maz;
        }
     }
   }
  for(i=2;i<=n;i++)
   { levo=0; gore=0;//boje levo i gore
     for(k=1;k<=m;k++)
      {if(mata[i][k]==0)
         { if(mata[i][k-1]>0)//levo ima boja
            { levo=boja[mata[i][k-1]];//koja je levo roditeljska
              mata[i][k]=mata[i][k-1];//preuzima levu boju
              if(mata[i-1][k]>0)//gore ima boja
               { gore=boja[mata[i-1][k]];//gore roditeljska
                 if(gore<levo) boja[mata[i][k]]=gore;//boja gore je manja
                 else boja[mata[i-1][k]]=levo;//cak i ako su iste
               }//gore
            }//levo ima boja
           else if (mata[i-1][k]>0)//gore ima boja
              mata[i][k]=mata[i-1][k];//pruzima boju odgore
           else//nova boja
             { boja.push_back(++maz);
               mata[i][k]=maz;
             }
          }//mata==0, nije crna
     }//for k
   }
  //cout<<endl;
  //stampa(mata, n, m);
  //cout<<endl;
  //stampa2(boja, maz);
  suma=0;
  for(i=1;i<=maz;i++)
    if(boja[i]==i) suma++;

  //cout<<endl;
  cout << suma << endl;
  return 0;
}
/*
4 4 5
1 1
2 2
3 3
4 4
1 3

1000 1000 14
1 1
2 2
3 3
4 4
1 3
5 4
6 3
7 2
8 1
3 5
2 5
1 5
1 6
1 8

2000 2000 14
1 1
2 2
3 3
4 4
1 3
5 4
6 3
7 2
8 1
3 5
2 5
1 5
1 6
1 8

2 4 2
2 2
2 4
*/